
   // from Wikipedia
   //
   //  compile with
   //    icc -openmp -mmic  simple_3.c -o simple_3
   //
   //  code sets the number of threads
   
#include <omp.h>
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char * arg[] )
{
   int th_id, nthreads;
                                          // set the thread count
    omp_set_num_threads(4);               // for 4 core cpu 
                                
                                          // does the following  
#pragma omp parallel private(th_id)       // in parallel over the threads
    {
       th_id = omp_get_thread_num();      // thread ID
       printf( "hello World from thread %d\n", th_id );
  
#pragma omp barrier                      // synchronize  threads

       if( th_id == 0 )                  // master thread
          {
             nthreads = omp_get_num_threads();
             printf( "There are %d threads\n", nthreads );
          }
    }
    return 0;
}
