
                       // compile with
                       //
                       //  icc -openmp -mmic simple_4.c -o simple_4
 
                       //  typical of calculations in parallel  
#include <omp.h>
#include <stdio.h>
#include <stdlib.h>

int main( int argc, char * arg[] )
{
#define N 100
#define CHUNKSIZE 12

int i, j, k;
double a[N];
int th_id;

                                           // initialize a[]
   for( i=0; i<N ; i++ )
     a[i] = (double)i;

                                           // smooth a[]
#pragma omp parallel private( th_id )
   {                                          
#pragma omp for  schedule( dynamic, CHUNKSIZE ) 
   for( i=1 ; i<N-1 ; i++ )
     {
       a[i] = 0.5*( a[i-1] + a[i+1] );
       th_id = omp_get_thread_num();      // thread ID
       fprintf( stderr, 
           "thread %3d   i %3d    average %5.2f %5.2f %5.2f\n", 
           th_id, i, a[i-1], a[i], a[i+1]  );
     }
   }
}

